package com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.equipTransfer;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yeejoin.amos.boot.biz.common.entity.BaseEntity;
import com.yeejoin.amos.boot.module.jg.api.dto.FieldChangeMeta;
import com.yeejoin.amos.boot.module.jg.api.dto.PipelineChangeItemDto;
import com.yeejoin.amos.boot.module.jg.api.entity.JgEquipTransfer;
import com.yeejoin.amos.boot.module.jg.api.enums.BusinessTypeEnum;
import com.yeejoin.amos.boot.module.jg.biz.edit.core.RouterEventPublisher;
import com.yeejoin.amos.boot.module.jg.biz.edit.event.BaseBizDataChangeEvent;
import com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.DefaultBizDataChangeHandler;
import com.yeejoin.amos.boot.module.ymt.api.enums.FlowStatusEnum;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 设备移交编辑处理器
 */
@Component
public class EquipTransferDataChangeHandler extends DefaultBizDataChangeHandler<BaseBizDataChangeEvent> {

    private final EquipTransferEditUpdateService equipTransferEditUpdateService;

    protected EquipTransferDataChangeHandler(RouterEventPublisher routerEventPublisher, ApplicationContext applicationContext, EquipTransferEditUpdateService equipTransferEditUpdateService) {
        super(routerEventPublisher, applicationContext);
        this.equipTransferEditUpdateService = equipTransferEditUpdateService;
    }

    @Override
    public String canHandleBizType() {
        return BusinessTypeEnum.JG_EQUIPMENT_HANDOVER.name();
    }

    @Override
    public List<FieldChangeMeta> postSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData, List<FieldChangeMeta> allChangeColumns, Map<String, List<PipelineChangeItemDto>> pipelineChangeItemMap) {
        return Collections.emptyList();
    }

    @Override
    public Boolean beforeCheck(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {
        return Boolean.TRUE;
    }

    /**
     * 管道专用
     * @param applyNo 单据号
     * 判断数据是实时落库，还是先存到json
     * @return 是否需要临时存储
     */
    @Override
    public Boolean requiresTemporarySave(String applyNo) {
        return false;
    }

    @Override
    public Set<String> getEqs(String applyNo) {
        return equipTransferEditUpdateService.getEqsByApplyNo(applyNo);
    }


    @Override
    public Boolean bizIsFinished(String applyNo) {
        JgEquipTransfer jgEquipTransfer = equipTransferEditUpdateService.getMainService().getOne(new LambdaQueryWrapper<JgEquipTransfer>().eq(JgEquipTransfer::getApplyNo, applyNo).select(BaseEntity::getSequenceNbr, JgEquipTransfer::getApplyStatus));
        return jgEquipTransfer.getApplyStatus().equals(String.valueOf(FlowStatusEnum.TO_BE_FINISHED.getCode()));
    }

    @Override
    public Set<String> getProjectContraptionIds(String applyNo) {
        Set<String> pIds = equipTransferEditUpdateService.getProIdsByApplyNo(applyNo);
        pIds.remove(null);
        pIds.remove("");
        return pIds;
    }

    @Override
    public void preSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {

    }
}
